/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO IoT Tutorial: 
 * Two NodeMCUs to communicate using the UDP protocol
 * This is NodeNCU-2
 * Tutorial link: https://osoyoo.com/?p=52973
 * CopyRIGHT www.osoyoo.com
*/


#include <ESP8266WiFi.h>
#include <WiFiUdp.h>

// Replace with your network credentials
const char* ssid = "Your_WiFi_SSID"; //Replace with your SSID
const char* password = "Your_WiFi_Password";  //Replace with your Password

// Destination IP and Port
IPAddress destIP(192, 168, 0, 15); // Replace with the IP of NodeMCU1
unsigned int destPort = 8888; // Replace with the port number of NodeMCU1

WiFiUDP udp;

void setup() {
Serial.begin(115200);
Serial.println("Connecting to WiFi");

WiFi.begin(ssid, password);
while (WiFi.status() != WL_CONNECTED) {
delay(1000);
Serial.println("Connecting to WiFi…");
}

Serial.println("WiFi connected");
Serial.println("IP address: ");
Serial.println(WiFi.localIP());

// Start UDP server
udp.begin(destPort);
}

void loop() {
// Receive data from NodeMCU1
int packetSize = udp.parsePacket();
if (packetSize) {
char incomingPacket[255];
udp.read(incomingPacket, 255);
Serial.print("Received packet: ");
Serial.println(incomingPacket);
}

// Send data to NodeMCU1
udp.beginPacket(destIP, destPort);
udp.write("Hello from NodeMCU2");
udp.endPacket();
delay(1000);
}
